import java.util.Scanner; // Para pedir input ao Utilizador

public class Vigenere {

   static final int CODIGO_ASCII_LETRA_A_MAIUSCULA = 65;

   static final int NUMERO_CARATERES_ALFABETO = 26;


   /* Metodo "cifrar"
    * Inputs: - plaintext
    *         - key
    * Output: - Devolve uma string cifrada
    */
   public static String cifrar (String plaintext, String key) {

     String ciphertext = "";

     String keyMaiusculas = key.toUpperCase();
     String plaintextMaiusculas = plaintext.toUpperCase();

     char[] keyCharArray = key.toCharArray();
     char[] keyMaiusculasCharArray = keyMaiusculas.toCharArray();
     char[] plaintextMaiusculasCharArray = plaintextMaiusculas.toCharArray();

     System.out.println("plaintext = " + plaintextMaiusculas);
     System.out.println("key = " + keyMaiusculas);

     int comprimentoKey = key.length();

     // System.out.println("Comprimento da Key = " + comprimentoKey);

     int indiceKey = 0;

     // Vamos percorrer todos os carateres do plaintext
     for (char c : plaintextMaiusculasCharArray) {

       // Vamos obter o codigo numerico da tabela ASCII do carater
      int codigoNumerico = (int)(c);

      // Vamos apurar o codigo ASCII do carater correspondente Cifrado
      // e o respetivo carater
       int novoCodigoNumerico = (codigoNumerico + keyMaiusculasCharArray[indiceKey]) % NUMERO_CARATERES_ALFABETO;
       int novoCodigoNumericoAlfabetico = novoCodigoNumerico + CODIGO_ASCII_LETRA_A_MAIUSCULA;
       char charCifrado = (char)(novoCodigoNumericoAlfabetico);

       // System.out.println("representacao ASCII de '" + novoCodigoNumericoAlfabetico + "' = " + charCifrado);

       // Avancamos para o carater seguinte da chave.
       // Caso ja tenhamos chegado ao ultimo carater da chave,
       // entao regressamos ao carater inicial
       if ( indiceKey < (comprimentoKey - 1) ) {
         indiceKey++;
       } else {
         indiceKey = 0;
       }

       ciphertext += charCifrado;
     }

     return (ciphertext);

   }  // FIM Metodo cifrar


   /* Metodo "decifrar"
    * Inputs: - ciphertext
    *         - key
    * Output: - Devolve uma string decifrada
    */
   public static String decifrar (String ciphertext, String key) {

     // System.out.println("ciphertext no inicio do metodo decifrar = " + ciphertext);

     String plaintext = "";

     String keyMaiusculas = key.toUpperCase();
     String ciphertextMaiusculas = ciphertext.toUpperCase();

     char[] keyMaiusculasCharArray = keyMaiusculas.toCharArray();
     char[] ciphertextMaiusculasCharArray = ciphertextMaiusculas.toCharArray();

     System.out.println("ciphertext = " + ciphertextMaiusculas);
     System.out.println("key = " + keyMaiusculas);

     //static final int CODIGO_ASCII_LETRA_A_MINUSCULA = 97;

     int comprimentoKey = key.length();

     //System.out.println("Comprimento da Key = " + comprimentoKey);

     int indiceKey = 0;

     // Vamos percorrer todos os carateres do ciphertext
     for (char c : ciphertextMaiusculasCharArray) {
       // Vamos obter o codigo numerico da tabela ASCII do carater
      int codigoNumerico = (int)(c);

       //System.out.println("codigo ASCII de '" + c + "' = " + codigoNumerico);
       // Vamos obter o codigo ASCII
       //System.out.println("c = " + c);

       int novoCodigoNumerico = (codigoNumerico - keyMaiusculasCharArray[indiceKey] + NUMERO_CARATERES_ALFABETO) % NUMERO_CARATERES_ALFABETO;

       int novoCodigoNumericoAlfabetico = novoCodigoNumerico + CODIGO_ASCII_LETRA_A_MAIUSCULA;

       // System.out.println("novoCodigoNumericoAlfabetico = " + novoCodigoNumericoAlfabetico);

       char charDecifrado = (char)(novoCodigoNumericoAlfabetico);

       // System.out.println("representacao ASCII de '" + novoCodigoNumericoAlfabetico + "' = " + charDecifrado);

       // Avancamos para o carater seguinte da chave.
       // Caso ja tenhamos chegado ao ultimo carater da chave,
       // entao regressamos ao carater inicial
       if ( indiceKey < (comprimentoKey - 1) ) {
         indiceKey++;
       } else {
         indiceKey = 0;
       }
       plaintext += charDecifrado;
     }

     return (plaintext);

   }  // FIM Metodo decifrar



   /*
    * Metodo "main"
    *
    */
   public static void main(String[] args) {

      char opcao = ' ';  // Opcao a introduzir pelo Utilizador
                        // C = cifrar
                        // D = decifrar
      System.out.println("CIFRA DE VIGENERE");
      System.out.println();


      Scanner reader = new Scanner(System.in);

      while ( (opcao != 'C') && (opcao != 'D') ) {
        System.out.println ("Digite a opção pretendida seguida de ENTER:");
        System.out.println ("C = Cifrar");
        System.out.println("D = Decifrar");
        // Ler input do utilizador
        opcao = reader.next().charAt(0);
      }


      if (opcao == 'C') {

        System.out.println("Qual e' o plaintext a cifrar?");
        String plaintext = System.console().readLine();

        System.out.println("Qual e' a Key?");
        String key = System.console().readLine();

        String ciphertext = cifrar(plaintext, key);

        System.out.println("ciphertext = " + ciphertext);

      } else if (opcao == 'D') {

        System.out.println("Qual e' o ciphertext a decifrar?");
        String ciphertext = System.console().readLine();

        System.out.println("Qual e' a Key?");
        String key = System.console().readLine();

        String plaintextDecifrado = decifrar(ciphertext, key);

        System.out.println("plaintext Decifrado = " + plaintextDecifrado);
      }

      System.out.println();

   }  // FIM main

} // FIM class
